package br.gov.mma;

import java.util.ArrayList;

import tree.HTFileNode;

//http://dsvwww.mma.gov.br/php/thesaurus_MMA/xml_tree_unico.php?vTermo=57924 Mecanica
//http://dsvwww.mma.gov.br/php/thesaurus_MMA/xml_tree_unico.php?vTermo=10000813 Mecanica classica
//http://dsvwww.mma.gov.br/php/thesaurus_MMA/xml_tree_unico.php?vTermo=41327 Fisica
//http://dsvwww.mma.gov.br/php/thesaurus_MMA/xml_tree_unico.php?vTermo=57983 
//http://dsvwww.mma.gov.br/php/thesaurus_MMA/xml_tree_unico.php?vTermo=98159 Volume dos resíduos sólidos

//http://dsvwww.mma.gov.br/php/thesaurus_MMA/xml_tree.php?vTermo=F letra f
public class Node {
	
	private Node pai;
	
	private String familia;
	
	public static final int TIPO_ROOT = 1;
	
	// Termo relacionado
	public static final int TIPO_TR = 2;
	
	// Termo geral -- PAI
	public static final int TIPO_TG = 3;
	
	// Termo específico -- FILHO
	public static final int TIPO_TE = 4;
	
	// Usado para -- Termo usado para
	public static final int TIPO_UP = 5;
	
	// Usa -- Termo que usa
	public static final int TIPO_USE = 6;
	
	private int tipo;
	
	private String nome;
	
	private String id;
	
	private int nivel;
	
	private String cor;
	
	private ArrayList trList = new ArrayList();
	
	private ArrayList tgList = new ArrayList();
	
	private ArrayList teList = new ArrayList();
	
	private ArrayList upList = new ArrayList();
	
	private ArrayList useList = new ArrayList();
	
	public Node getPai() {
		return pai;
	}

	public void setPai(Node pai) {
		this.pai = pai;
	}

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	public int getTipo() {
		return tipo;
	}

	public void setTipo(int tipo) {
		this.tipo = tipo;
	}
	
	public void setTipoNivel( String tipoNivel ) {
		int nLength = 2;
		if( tipoNivel.length() < 2 ) {
			nLength++;
		}
		String tipo = "";
		if( tipoNivel.equals( "TR" ) || tipoNivel.equals( "UP" ) || tipoNivel.equals( "USE" ) ) {
			tipo = tipoNivel;
			setNivel( 1 );
		}
		else {
			String nivel = tipoNivel.substring( nLength );
			
			setNivel( nivel );
			
			tipo = tipoNivel.replaceAll(tipoNivel.substring( nLength ), "");
		}
		
		if( tipo.equals( "TR" ) ) {
			setTipo( Node.TIPO_TR );
		}
		else if( tipo.equals( "TG" ) ) {
			setTipo( Node.TIPO_TG );
		}
		else if( tipo.equals( "TE" ) ) {
			setTipo( Node.TIPO_TE );
		}
		else if( tipo.equals( "UP" ) ) {
			setTipo( Node.TIPO_UP );
		}
		else {
			setTipo( Node.TIPO_USE );
		}
	}
	
	public int getNivel() {
		return nivel;
	}
	
	public void setNivel(String nivel) {
		this.nivel = Integer.parseInt( nivel );
	}
	
	public void setNivel(int nivel) {
		this.nivel = nivel;
	}
	
	public void addTrNode( Node node ) {
		trList.add( node );
	}
	
	public Node[] getTrNodes() {
		Object[] objects = trList.toArray();
		Node[] nodes = new Node[ objects.length ];
		for( int i =0; i < objects.length; i++ ) {
			nodes[ i ] = (Node) objects[ i ];
		}
		return nodes;
	}
	
	public void addTgNode( Node node ) {
		tgList.add( node );
	}
	
	public Node[] getTgNodes() {
		Object[] objects = tgList.toArray();
		Node[] nodes = new Node[ objects.length ];
		for( int i =0; i < objects.length; i++ ) {
			nodes[ i ] = (Node) objects[ i ];
		}
		return nodes;
	}
	
	public void addTeNode( Node node ) {
		teList.add( node );
	}
	
	public Node[] getTeNodes() {
		Object[] objects = teList.toArray();
		Node[] nodes = new Node[ objects.length ];
		for( int i =0; i < objects.length; i++ ) {
			nodes[ i ] = (Node) objects[ i ];
		}
		return nodes;
	}
	
	public void addUpNode( Node node ) {
		upList.add( node );
	}
	
	public Node[] getUpNodes() {
		Object[] objects = upList.toArray();
		Node[] nodes = new Node[ objects.length ];
		for( int i =0; i < objects.length; i++ ) {
			nodes[ i ] = (Node) objects[ i ];
		}
		return nodes;
	}
	
	public void addUseNode( Node node ) {
		useList.add( node );
	}
	
	public Node[] getUseNodes() {
		Object[] objects = useList.toArray();
		Node[] nodes = new Node[ objects.length ];
		for( int i =0; i < objects.length; i++ ) {
			nodes[ i ] = (Node) objects[ i ];
		}
		return nodes;
	}
	
	public void addNode( Node node ) {
		node.setPai( this );
		switch( node.getTipo() ) {
			case TIPO_TE:
				addTeNode( node );
				break;
			case TIPO_TG:
				addTgNode( node );
				break;
			case TIPO_TR:
				addTrNode( node );
				break;
			case TIPO_UP:
				addUpNode( node );
				break;
			case TIPO_USE:
				addUseNode( node );
				break;
		}
	}
	
	public String toString() {
		String ident = "";
		
		for( int i =0; i< getNivel(); i++ ) {
			ident += "\t";
		}
		
		String out = ident + "Node " + getNome() + " { id : " + getId() + "; tipo : " + getTipo() + "; nivel : " + getNivel() + " }\n";
		out += ident + "Termos Específicos:\n";
		for( int i=0; i < getTeNodes().length; i++ ) {
			out += getTeNodes()[ i ];
		}
		out += ident + "Termos Gerais:\n";
		for( int i=0; i < getTgNodes().length; i++ ) {
			out += getTgNodes()[ i ];
		}
		out += ident + "Termos Relativos:\n";
		for( int i=0; i < getTrNodes().length; i++ ) {
			out += getTrNodes()[ i ];
		}
		
		out += ident + "Usados Para ou Use:\n";
		for( int i=0; i < getUpNodes().length; i++ ) {
			out += getUpNodes()[ i ];
		}
		out += ident + "Fim Node " + getNome() + "\n";
		return out;
	}
	
	public HTFileNode buildTree( String colorNode, String colorTextNode, String colorRelationalNode, String colorTextRelationNode ) {
		HTFileNode fnode = new HTFileNode( colorNode, colorTextNode, colorRelationalNode, colorTextRelationNode );
		
		fnode.setName( getNome() );
		fnode.setFamilia( getFamilia() );
		fnode.setLeafNode(false);
		
		fnode.setID( getId() );
		
		String url = getId();
		String urlSplit[] = url.split("_");
		
		url = "http://10.1.1.65/~01228334145/thesaurus/display_termo.php?vTermo="+urlSplit[1];
		
		fnode.setURL(url);
		
		switch( getTipo() ) {
			case TIPO_ROOT:
				fnode.setHint( "Raíz" );
				fnode.setColor( colorNode );
//				fnode.setColor( "0x" + getCor() );
				break;
			case TIPO_TE:
				fnode.setColor( "0x" + getCor() );
				fnode.setHint( "TE - Termo Específico" );
				break;
			case TIPO_TG:
				fnode.setColor( "0x" + getCor() );
				fnode.setHint( "TG - Termo Geral" );
				break;
			case TIPO_TR:
				fnode.setColor( "0x" + getCor() );
				fnode.setHint( "TR - Relacionado" );
				break;
			case TIPO_UP:
				fnode.setColor( "0x" + getCor() );
				fnode.setHint( "UP - Usado Para" );
				break;
			case TIPO_USE:
				fnode.setColor( "0x" + getCor() );
				fnode.setHint( "USE" );
				break;
		}
		
		for( int i=0; i < getTeNodes().length; i++ ) {
			fnode.addChild( getTeNodes()[ i ].buildTree(colorNode, colorTextNode, colorRelationalNode, colorTextRelationNode) );
		}
		
		if( getTrNodes().length > 0 ) {
			HTFileNode ftrNode = new HTFileNode( colorNode, colorTextNode, colorRelationalNode, colorTextRelationNode );
			
			ftrNode.setName( "TR" );
			
			ftrNode.setLeafNode( false );
			
			ftrNode.setHasHint( false );
			
			ftrNode.setID( "TR_" + System.currentTimeMillis() );
			
			ftrNode.setColor( "0xf4f966" );
			
			for( int i=0; i < getTrNodes().length; i++ ) {
				ftrNode.addChild( getTrNodes()[ i ].buildTree(colorNode, colorTextNode, colorRelationalNode, colorTextRelationNode) );
			}
			fnode.addChild( ftrNode );
		}
		
		for( int i=0; i < getTgNodes().length; i++ ) {
			fnode.addChild( getTgNodes()[ i ].buildTree(colorNode, colorTextNode, colorRelationalNode, colorTextRelationNode) );
		}
		
		
		if( getUpNodes().length > 0 ) {
			HTFileNode fupNode = new HTFileNode( colorNode, colorTextNode, colorRelationalNode, colorTextRelationNode );
			
			fupNode.setName( "UP" );
			
			fupNode.setLeafNode(false);
			
			fupNode.setHasHint(false);
			
			fupNode.setID( "UP_" + System.currentTimeMillis() );
			
			fupNode.setURL("http://10.1.1.65/~01228334145/thesaurus/display_termo.php?vTermo=39811");
			
			fupNode.setColor( "0xf7cb52" );
			
			for( int i=0; i < getUpNodes().length; i++ ) {
				fupNode.addChild( getUpNodes()[ i ].buildTree(colorNode, colorTextNode, colorRelationalNode, colorTextRelationNode) );
			}
			fnode.addChild( fupNode );
		}
		
		if( getUseNodes().length > 0 ) {
			HTFileNode fuseNode = new HTFileNode( colorNode, colorTextNode, colorRelationalNode, colorTextRelationNode );
			
			fuseNode.setName( "USE" );
			
			fuseNode.setLeafNode(false);
			
			fuseNode.setHasHint(false);
			
			fuseNode.setID( "UP_" + System.currentTimeMillis() );
			
			fuseNode.setColor( "0xf7cb52" );
			
			fuseNode.setURL("http://10.1.1.65/~01228334145/thesaurus/display_termo.php?vTermo=39811");
			
			for( int i=0; i < getUseNodes().length; i++ ) {
				fuseNode.addChild( getUseNodes()[ i ].buildTree(colorNode, colorTextNode, colorRelationalNode, colorTextRelationNode) );
			}
			fnode.addChild( fuseNode );
		}
		
		return fnode;
	}
	
	public boolean hasChild() {
		
		if( getTeNodes().length > 0 ) {
			return true;
		}
		
		if( getTrNodes().length > 0 ) {
			return true;
		}
		
		if( getTgNodes().length > 0 ) {
			return true;
		}
		
		if( getUpNodes().length > 0 ) {
			return true;
		}
		
		if( getUseNodes().length > 0 ) {
			return true;
		}
		
		return false;
	}

	public String getFamilia() {
		return familia;
	}

	public void setFamilia(String familia) {
		this.familia = familia;
	}

	public String getCor() {
		return cor;
	}

	public void setCor(String cor) {
		this.cor = cor;
	}
}